Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(rvision 77022)
+++ apps/app_queue.c	(copie de travail)
@@ -160,6 +160,8 @@
 "calling party's channel once they are connected to a queue member.\n"
 "  The timeout will cause the queue to fail out after a specified number of\n"
 "seconds, checked between each queues.conf 'timeout' and 'retry' cycle.\n"
+"  If the dialplan variable QUEUE_MOH is set, then app_queue will use this\n"
+"moh class instead of the one set in queues.conf.\n"
 "  This application sets the following channel variable upon completion:\n"
 "      QUEUESTATUS    The status of the call as a text string, one of\n"
 "             TIMEOUT | FULL | JOINEMPTY | LEAVEEMPTY | JOINUNAVAIL | LEAVEUNAVAIL | CONTINUE\n";
@@ -3457,6 +3459,7 @@
 {
 	int res=-1;
 	int ringing=0;
+	const char *persomoh;
 	const char *user_priority;
 	const char *max_penalty_str;
 	int prio;
@@ -3550,7 +3553,12 @@
 		if (ringing) {
 			ast_indicate(chan, AST_CONTROL_RINGING);
 		} else {
-			ast_moh_start(chan, qe.moh, NULL);
+			persomoh = pbx_builtin_getvar_helper(chan, "QUEUE_MOH");
+			if (persomoh) {
+					ast_moh_start(chan, persomoh, NULL);
+			}
+			else
+				ast_moh_start(chan, qe.moh, NULL);
 		}
 
 		/* This is the wait loop for callers 2 through maxlen */
